tbb_misc.cpp File Reference
`#include "tbb/tbb_stddef.h"`
`#include "tbb_assert_impl.h"`
`#include "tbb/tbb_exception.h"`
`#include "tbb/tbb_machine.h"`
`#include "tbb_misc.h"`
`#include "tbb_version.h"`
`#include <cstdio>`
`#include <cstdlib>`
`#include <stdexcept>`
`#include <cstring>`
`#include <unistd.h>`
Include dependency graph for tbb_misc.cpp:

Go to the source code of this file.

## Namespaces

| tbb
| The graph class.
| tbb::internal
| Identifiers declared inside namespace internal should never be used directly by client code.

## Macros

#define | __TBB_STD_RETHROW_EXCEPTION_POSSIBLY_BROKEN
#define | PRINT_ERROR_AND_ABORT(exc_name, msg)
#define | DO_THROW(exc, init_args) PRINT_ERROR_AND_ABORT(#exc, #init_args)

## Functions

size_t | tbb::internal::DefaultSystemPageSize ()
| Returns OS regular memory page size. More...
void __TBB_EXPORTED_FUNC | tbb::internal::handle_perror (int error_code, const char *aux_info)
| Throws std::runtime_error with what() returning error_code description prefixed with aux_info. More...
void __TBB_EXPORTED_FUNC | tbb::internal::throw_bad_last_alloc_exception_v4 ()
| Obsolete. More...
void __TBB_EXPORTED_FUNC | tbb::internal::throw_exception_v4 (exception_id)
| Gathers all throw operators in one place. More...
void | tbb::internal::fix_broken_rethrow ()
bool | tbb::internal::gcc_rethrow_exception_broken ()
void | tbb::internal::PrintVersion ()
| Prints TBB version information on stderr. More...
void | tbb::internal::PrintExtraVersionInfo (const char *category, const char *format,...)
| Prints arbitrary extra TBB version information on stderr. More...
void | tbb::internal::PrintRMLVersionInfo (void *arg, const char *server_info)
| A callback routine to print RML version information on stderr. More...
bool | tbb::internal::cpu_has_speculation ()
| check for transaction support. More...
int __TBB_EXPORTED_FUNC | tbb::TBB_runtime_interface_version ()
| The function returns the interface version of the TBB shared library being used. More...

## Variables

static const char | tbb::internal::VersionString [] = "\0" TBB_VERSION_STRINGS
static bool | tbb::internal::PrintVersionFlag = false

## Macro Definition Documentation

## __TBB_STD_RETHROW_EXCEPTION_POSSIBLY_BROKEN

#define __TBB_STD_RETHROW_EXCEPTION_POSSIBLY_BROKEN

Value:
(__GLIBCXX__ && __TBB_GLIBCXX_VERSION>=40700 && __TBB_GLIBCXX_VERSION<60000 \
&& TBB_USE_EXCEPTIONS && !TBB_USE_CAPTURED_EXCEPTION)

Definition at line 40 of file tbb_misc.cpp.

## DO_THROW

#define DO_THROW | ( |  | exc,
|  |  | init_args
| ) |  | PRINT_ERROR_AND_ABORT(#exc, #init_args)

Definition at line 67 of file tbb_misc.cpp.

## PRINT_ERROR_AND_ABORT

#define PRINT_ERROR_AND_ABORT | ( |  | exc_name,
|  |  | msg
| ) |  |

Value:
fprintf (stderr, "Exception %s with message %s would've been thrown, " \
"if exception handling were not disabled. Aborting.\n", exc_name, msg); \
fflush(stderr); \
std::abort();

Definition at line 62 of file tbb_misc.cpp.

TBB_USE_CAPTURED_EXCEPTION
#define TBB_USE_CAPTURED_EXCEPTION
Definition: tbb_config.h:493
TBB_USE_EXCEPTIONS
#define TBB_USE_EXCEPTIONS
Definition: tbb_config.h:464

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.